MapSerializer
Date: 2016-12-04

com.fasterxml.jackson.databind.ser.std

## Class MapSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<java.util.Map<?,?>>
      - - com.fasterxml.jackson.databind.ser.std.MapSerializer

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, java.io.Serializable

      public class MapSerializer
      extends ContainerSerializer<java.util.Map<?,?>>
      implements ContextualSerializer

  Standard serializer implementation for serializing {link java.util.Map} types.

  Note: about the only configurable setting currently is ability to filter out entries with specified names.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected PropertySerializerMap` | `_dynamicValueSerializers` If value type can not be statically determined, mapping from runtime value types to serializers are stored in this object.
    `protected java.lang.Object` | `_filterId` Id of the property filter to use, if any; null if none.
    `protected java.util.Set<java.lang.String>` | `_ignoredEntries` Set of entries to omit during serialization, if any
    `protected JsonSerializer<java.lang.Object>` | `_keySerializer` Key serializer to use, if it can be statically determined
    `protected JavaType` | `_keyType` Declared type of keys
    `protected BeanProperty` | `_property` Map-valued property being serialized with this instance
    `protected boolean` | `_sortKeys` Flag set if output is forced to be sorted by keys (usually due to annotation).
    `protected java.lang.Object` | `_suppressableValue` Value that indicates suppression mechanism to use for values contained; either one of values of `JsonInclude.Include`, or actual object to compare against ("default value").
    `protected JsonSerializer<java.lang.Object>` | `_valueSerializer` Value serializer to use, if it can be statically determined
    `protected JavaType` | `_valueType` Declared type of contained values
    `protected boolean` | `_valueTypeIsStatic` Whether static types should be used for serialization of values or not (if not, dynamic runtime type is used)
    `protected TypeSerializer` | `_valueTypeSerializer` Type identifier serializer used for values, if any.
    `protected static JavaType` | `UNSPECIFIED_TYPE`

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `MapSerializer(MapSerializer src, BeanProperty property, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer, java.util.Set<java.lang.String> ignoredEntries)`
    `protected` | `MapSerializer(MapSerializer src, java.lang.Object filterId, boolean sortKeys)`
    `protected` | `MapSerializer(MapSerializer src, TypeSerializer vts)` Deprecated.
    `protected` | `MapSerializer(MapSerializer src, TypeSerializer vts, java.lang.Object suppressableValue)`
    `protected` | `MapSerializer(java.util.Set<java.lang.String> ignoredEntries, JavaType keyType, JavaType valueType, boolean valueTypeIsStatic, TypeSerializer vts, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_ensureOverride()`
    `protected JsonSerializer<java.lang.Object>` | `_findAndAddDynamic(PropertySerializerMap map, java.lang.Class<?> type, SerializerProvider provider)`
    `protected JsonSerializer<java.lang.Object>` | `_findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)`
    `protected java.util.Map<?,?>` | `_orderEntries(java.util.Map<?,?> input, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, java.lang.Object suppressableValue)`
    `MapSerializer` | `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
    `protected void` | `_writeNullKeyedEntry(com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, java.lang.Object suppressableValue, java.lang.Object value)`
    `void` | `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
    `static MapSerializer` | `construct(java.util.Set<java.lang.String> ignoredEntries, JavaType mapType, boolean staticValueType, TypeSerializer vts, JsonSerializer<java.lang.Object> keySerializer, JsonSerializer<java.lang.Object> valueSerializer, java.lang.Object filterId)`
    `static MapSerializer` | `construct(java.lang.String[] ignoredList, JavaType mapType, boolean staticValueType, TypeSerializer vts, JsonSerializer<java.lang.Object> keySerializer, JsonSerializer<java.lang.Object> valueSerializer, java.lang.Object filterId)` Deprecated. Since 2.8 use the other overload
    `JsonSerializer<?>` | `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
    `JsonSerializer<?>` | `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
    `JavaType` | `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
    `JsonSerializer<?>` | `getKeySerializer()` Accessor for currently assigned key serializer.
    `JsonNode` | `getSchema(SerializerProvider provider, java.lang.reflect.Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
    `boolean` | `hasSingleElement(java.util.Map<?,?> value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
    `boolean` | `isEmpty(SerializerProvider prov, java.util.Map<?,?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
    `void` | `serialize(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `void` | `serializeFields(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` General-purpose serialization for contents, where we do not necessarily know the value serialization, but we do know that no value suppression is needed (which simplifies processing a bit)
    `void` | `serializeFieldsUsing(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, JsonSerializer<java.lang.Object> ser)` Method called to serialize fields, when the value type is statically known, so that value serializer is passed and does not need to be fetched from provider.
    `void` | `serializeFilteredFields(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, PropertyFilter filter)` Deprecated.
    `void` | `serializeFilteredFields(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, PropertyFilter filter, java.lang.Object suppressableValue)` Helper method used when we have a JSON Filter to use for potentially filtering out Map entries.
    `void` | `serializeOptionalFields(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, java.lang.Object suppressableValue)` Serialization method called when exclusion filtering needs to be applied.
    `protected void` | `serializeTypedFields(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider)` Deprecated.
    `void` | `serializeTypedFields(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, java.lang.Object suppressableValue)`
    `void` | `serializeWithType(java.util.Map<?,?> value, com.fasterxml.jackson.core.JsonGenerator gen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
    `MapSerializer` | `withContentInclusion(java.lang.Object suppressableValue)` Mutant factory for constructing an instance with different inclusion strategy for content (Map values).
    `MapSerializer` | `withFilterId(java.lang.Object filterId)` Mutant factory method that is called if contextual configuration indicates that a specific filter (as specified by `filterId`) is to be used for serialization.
    `MapSerializer` | `withResolved(BeanProperty property, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer, java.util.Set<java.lang.String> ignored, boolean sortKeys)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

      `hasContentTypeAnnotation, isEmpty, withValueTypeSerializer`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### UNSPECIFIED_TYPE

          protected static final JavaType UNSPECIFIED_TYPE

    - #### _property

          protected final BeanProperty _property

      Map-valued property being serialized with this instance

    - #### _ignoredEntries

          protected final java.util.Set<java.lang.String> _ignoredEntries

      Set of entries to omit during serialization, if any

    - #### _valueTypeIsStatic

          protected final boolean _valueTypeIsStatic

      Whether static types should be used for serialization of values or not (if not, dynamic runtime type is used)

    - #### _keyType

          protected final JavaType _keyType

      Declared type of keys

    - #### _valueType

          protected final JavaType _valueType

      Declared type of contained values

    - #### _keySerializer

          protected JsonSerializer<java.lang.Object> _keySerializer

      Key serializer to use, if it can be statically determined

    - #### _valueSerializer

          protected JsonSerializer<java.lang.Object> _valueSerializer

      Value serializer to use, if it can be statically determined

    - #### _valueTypeSerializer

          protected final TypeSerializer _valueTypeSerializer

      Type identifier serializer used for values, if any.

    - #### _dynamicValueSerializers

          protected PropertySerializerMap _dynamicValueSerializers

      If value type can not be statically determined, mapping from runtime value types to serializers are stored in this object.

    - #### _filterId

          protected final java.lang.Object _filterId

      Id of the property filter to use, if any; null if none.
      Since:
        2.3

    - #### _sortKeys

          protected final boolean _sortKeys

      Flag set if output is forced to be sorted by keys (usually due to annotation).
      Since:
        2.4

    - #### _suppressableValue

          protected final java.lang.Object _suppressableValue

      Value that indicates suppression mechanism to use for values contained; either one of values of `JsonInclude.Include`, or actual object to compare against ("default value"). Note that inclusion value for Map instance itself is handled by caller (POJO property that refers to the Map value).
      Since:
        2.5

  - ### Constructor Detail

    - #### MapSerializer

          protected MapSerializer(java.util.Set<java.lang.String> ignoredEntries,
                       JavaType keyType,
                       JavaType valueType,
                       boolean valueTypeIsStatic,
                       TypeSerializer vts,
                       JsonSerializer<?> keySerializer,
                       JsonSerializer<?> valueSerializer)

      Since:
        2.5

    - #### MapSerializer

          protected MapSerializer(MapSerializer src,
                       BeanProperty property,
                       JsonSerializer<?> keySerializer,
                       JsonSerializer<?> valueSerializer,
                       java.util.Set<java.lang.String> ignoredEntries)

    - #### MapSerializer

          @Deprecated
          protected MapSerializer(MapSerializer src,
                                  TypeSerializer vts)

      Deprecated.

    - #### MapSerializer

          protected MapSerializer(MapSerializer src,
                       TypeSerializer vts,
                       java.lang.Object suppressableValue)

      Since:
        2.5

    - #### MapSerializer

          protected MapSerializer(MapSerializer src,
                       java.lang.Object filterId,
                       boolean sortKeys)

  - ### Method Detail

    - #### _ensureOverride

          protected void _ensureOverride()

      Since:
        2.5

    - #### _withValueTypeSerializer

          public MapSerializer _withValueTypeSerializer(TypeSerializer vts)

      Description copied from class: `ContainerSerializer`
      Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
      Specified by:
        `_withValueTypeSerializer` in class `ContainerSerializer<java.util.Map<?,?>>`

    - #### withResolved

          public MapSerializer withResolved(BeanProperty property,
                                   JsonSerializer<?> keySerializer,
                                   JsonSerializer<?> valueSerializer,
                                   java.util.Set<java.lang.String> ignored,
                                   boolean sortKeys)

      Since:
        2.4

    - #### withFilterId

          public MapSerializer withFilterId(java.lang.Object filterId)

      Description copied from class: `JsonSerializer`
      Mutant factory method that is called if contextual configuration indicates that a specific filter (as specified by `filterId`) is to be used for serialization.

      Default implementation simply returns `this`; sub-classes that do support filtering will need to create and return new instance if filter changes.

      Overrides:
        `withFilterId` in class `JsonSerializer<java.util.Map<?,?>>`

    - #### withContentInclusion

          public MapSerializer withContentInclusion(java.lang.Object suppressableValue)

      Mutant factory for constructing an instance with different inclusion strategy for content (Map values).
      Since:
        2.5

    - #### construct

          @Deprecated
          public static MapSerializer construct(java.lang.String[] ignoredList,
                                           JavaType mapType,
                                           boolean staticValueType,
                                           TypeSerializer vts,
                                           JsonSerializer<java.lang.Object> keySerializer,
                                           JsonSerializer<java.lang.Object> valueSerializer,
                                           java.lang.Object filterId)

      Deprecated. Since 2.8 use the other overload
      Since:
        2.3

    - #### construct

          public static MapSerializer construct(java.util.Set<java.lang.String> ignoredEntries,
                                JavaType mapType,
                                boolean staticValueType,
                                TypeSerializer vts,
                                JsonSerializer<java.lang.Object> keySerializer,
                                JsonSerializer<java.lang.Object> valueSerializer,
                                java.lang.Object filterId)

      Since:
        2.8

    - #### createContextual

          public JsonSerializer<?> createContextual(SerializerProvider provider,
                                           BeanProperty property)
                                             throws JsonMappingException

      Description copied from interface: `ContextualSerializer`
      Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualSerializer`
      Parameters:
        `provider` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerSerializer`
      Accessor for finding declared (static) element type for type this serializer is used for.
      Specified by:
        `getContentType` in class `ContainerSerializer<java.util.Map<?,?>>`

    - #### getContentSerializer

          public JsonSerializer<?> getContentSerializer()

      Description copied from class: `ContainerSerializer`
      Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.
      Specified by:
        `getContentSerializer` in class `ContainerSerializer<java.util.Map<?,?>>`

    - #### isEmpty

          public boolean isEmpty(SerializerProvider prov,
                        java.util.Map<?,?> value)

      Description copied from class: `JsonSerializer`
      Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

      Default implementation will consider only null values to be empty.

      NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

      Overrides:
        `isEmpty` in class `JsonSerializer<java.util.Map<?,?>>`

    - #### hasSingleElement

          public boolean hasSingleElement(java.util.Map<?,?> value)

      Description copied from class: `ContainerSerializer`
      Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

      Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

      Specified by:
        `hasSingleElement` in class `ContainerSerializer<java.util.Map<?,?>>`

    - #### getKeySerializer

          public JsonSerializer<?> getKeySerializer()

      Accessor for currently assigned key serializer. Note that this may return null during construction of `MapSerializer`: depedencies are resolved during `createContextual(com.fasterxml.jackson.databind.SerializerProvider, com.fasterxml.jackson.databind.BeanProperty)` method (which can be overridden by custom implementations), but for some dynamic types, it is possible that serializer is only resolved during actual serialization.
      Since:
        2.0

    - #### serialize

          public void serialize(java.util.Map<?,?> value,
                       com.fasterxml.jackson.core.JsonGenerator gen,
                       SerializerProvider provider)
                         throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `StdSerializer<java.util.Map<?,?>>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `java.io.IOException`

    - #### serializeWithType

          public void serializeWithType(java.util.Map<?,?> value,
                               com.fasterxml.jackson.core.JsonGenerator gen,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws java.io.IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

      For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, gen);
            serialize(value, gen, provider);
            typeSer.writeTypeSuffixForScalar(value, gen);

      and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.
      Overrides:
        `serializeWithType` in class `JsonSerializer<java.util.Map<?,?>>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `java.io.IOException`

    - #### serializeFields

          public void serializeFields(java.util.Map<?,?> value,
                             com.fasterxml.jackson.core.JsonGenerator gen,
                             SerializerProvider provider)
                               throws java.io.IOException

      General-purpose serialization for contents, where we do not necessarily know the value serialization, but we do know that no value suppression is needed (which simplifies processing a bit)
      Throws:
        `java.io.IOException`

    - #### serializeOptionalFields

          public void serializeOptionalFields(java.util.Map<?,?> value,
                                     com.fasterxml.jackson.core.JsonGenerator gen,
                                     SerializerProvider provider,
                                     java.lang.Object suppressableValue)
                                       throws java.io.IOException

      Serialization method called when exclusion filtering needs to be applied.
      Throws:
        `java.io.IOException`

    - #### serializeFieldsUsing

          public void serializeFieldsUsing(java.util.Map<?,?> value,
                                  com.fasterxml.jackson.core.JsonGenerator gen,
                                  SerializerProvider provider,
                                  JsonSerializer<java.lang.Object> ser)
                                    throws java.io.IOException

      Method called to serialize fields, when the value type is statically known, so that value serializer is passed and does not need to be fetched from provider.
      Throws:
        `java.io.IOException`

    - #### serializeFilteredFields

          public void serializeFilteredFields(java.util.Map<?,?> value,
                                     com.fasterxml.jackson.core.JsonGenerator gen,
                                     SerializerProvider provider,
                                     PropertyFilter filter,
                                     java.lang.Object suppressableValue)
                                       throws java.io.IOException

      Helper method used when we have a JSON Filter to use for potentially filtering out Map entries.
      Throws:
        `java.io.IOException`
      Since:
        2.5

    - #### serializeFilteredFields

          @Deprecated
          public void serializeFilteredFields(java.util.Map<?,?> value,
                                                com.fasterxml.jackson.core.JsonGenerator gen,
                                                SerializerProvider provider,
                                                PropertyFilter filter)
                                       throws java.io.IOException

      Deprecated.
      Throws:
        `java.io.IOException`

    - #### serializeTypedFields

          public void serializeTypedFields(java.util.Map<?,?> value,
                                  com.fasterxml.jackson.core.JsonGenerator gen,
                                  SerializerProvider provider,
                                  java.lang.Object suppressableValue)
                                    throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        2.5

    - #### serializeTypedFields

          @Deprecated
          protected void serializeTypedFields(java.util.Map<?,?> value,
                                             com.fasterxml.jackson.core.JsonGenerator gen,
                                             SerializerProvider provider)
                                       throws java.io.IOException

      Deprecated.
      Throws:
        `java.io.IOException`

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                           java.lang.reflect.Type typeHint)

      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdSerializer<java.util.Map<?,?>>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.

    - #### acceptJsonFormatVisitor

          public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                     JavaType typeHint)
                                       throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation specifies no format. This behavior is usually overriden by custom serializers.
      Specified by:
        `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
      Overrides:
        `acceptJsonFormatVisitor` in class `StdSerializer<java.util.Map<?,?>>`
        `typeHint` - Type of element (entity like property) being visited
      Throws:
        `JsonMappingException`

    - #### _findAndAddDynamic

          protected final JsonSerializer<java.lang.Object> _findAndAddDynamic(PropertySerializerMap map,
                                                            java.lang.Class<?> type,
                                                            SerializerProvider provider)
                                                                       throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _findAndAddDynamic

          protected final JsonSerializer<java.lang.Object> _findAndAddDynamic(PropertySerializerMap map,
                                                            JavaType type,
                                                            SerializerProvider provider)
                                                                       throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _orderEntries

          protected java.util.Map<?,?> _orderEntries(java.util.Map<?,?> input,
                                         com.fasterxml.jackson.core.JsonGenerator gen,
                                         SerializerProvider provider,
                                         java.lang.Object suppressableValue)
                                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _writeNullKeyedEntry

          protected void _writeNullKeyedEntry(com.fasterxml.jackson.core.JsonGenerator gen,
                                  SerializerProvider provider,
                                  java.lang.Object suppressableValue,
                                  java.lang.Object value)
                                       throws java.io.IOException

      Throws:
        `java.io.IOException`